DEFINT A-Z
OPTION EXPLICIT

DECLARE FUNCTION AllocMem (BYVAL Size%) AS INTEGER
DECLARE SUB FreeMem (BYVAL Segment%)

DECLARE FUNCTION MoveMem (BYVAL DestSeg%, BYVAL DestOffset%, BYVAL SrcSeg%, BYVAL SrcOffset%, BYVAL Length%) AS INTEGER

DECLARE FUNCTION PushVar ALIAS "MoveMem" (BYVAL Segment%, BYVAL Offset%, SEG Variable AS ANY, BYVAL Length%) AS INTEGER
DECLARE FUNCTION PopVar ALIAS "MoveMem" (SEG Variable AS ANY, BYVAL Segment%, BYVAL Offset%, BYVAL Length%) AS INTEGER

DIM Segment
DIM Index
DIM MyArray(1 TO 100)

FOR Index = 1 TO 100
  MyArray(Index) = Index
NEXT Index



CLS

PRINT "SETMEM(0)      :"; SETMEM(0)
PRINT "SETMEM(-128000):"; SETMEM(-128000)

Segment = AllocMem(&HFA00)

PRINT "Segment        :"; Segment
IF Segment THEN


  PRINT "PushVar        :";
  PRINT PushVar(Segment, 0, MyArray(1), 200)

  FOR Index = 1 TO 100
    MyArray(Index) = 0
  NEXT Index

  PRINT "PopVar         :";
  PRINT PopVar(MyArray(1), Segment, 0, 200)

  PRINT "Array 1,50,100 :";
  PRINT MyArray(1); MyArray(50); MyArray(100)


  FreeMem (Segment)
END IF

PRINT "SETMEM(128000) :"; SETMEM(128000)


