DEFINT A-Z
OPTION EXPLICIT

DECLARE FUNCTION AllocMem (BYVAL Size%) AS INTEGER
DECLARE SUB FreeMem (BYVAL Segment%)

DECLARE FUNCTION MoveMem (BYVAL DestSeg%, BYVAL DestOffset%, BYVAL SrcSeg%, BYVAL SrcOffset%, BYVAL Length%) AS INTEGER

DECLARE FUNCTION PushVar ALIAS "MoveMem" (BYVAL Segment%, BYVAL Offset%, SEG Variable AS ANY, BYVAL Length%) AS INTEGER
DECLARE FUNCTION PopVar ALIAS "MoveMem" (SEG Variable AS ANY, BYVAL Segment%, BYVAL Offset%, BYVAL Length%) AS INTEGER

DIM Segment
DIM Memory&
DIM Index
DIM img(1 TO 130)
DIM KeyCode, Direction, a$

Memory& = SETMEM(-128000)
Segment = AllocMem(&HFA00)

IF Segment THEN

  SCREEN 13

  DEF SEG = Segment

  FOR Index = 0 TO 3
    BLOAD "Arrow" + MID$(STR$(Index + 1), 2) + ".img", Index * 260
  NEXT Index

  DEF SEG

  DO
    Memory& = PopVar(img(1), Segment, Direction * 260, 260)

    PUT (0, 0), img

    DO
      a$ = INKEY$
    LOOP UNTIL LEN(a$)

    KeyCode = ASC(RIGHT$(a$, 1))
    IF LEN(a$) > 1 THEN KeyCode = -KeyCode

    PUT (0, 0), img

    SELECT CASE KeyCode
    CASE -72: Direction = 0
    CASE -75: Direction = 3
    CASE -77: Direction = 1
    CASE -80: Direction = 2
    END SELECT



  LOOP UNTIL KeyCode = 27


  SCREEN 0

  FreeMem (Segment)
END IF

Memory& = SETMEM(128000)


